/*
 * This file is part of the Java SIP library, an open source SIP library. Please see
 * http://jsip.sourceforge.net for more information
 *
 * Copyright (c) 2001 The MITRE Corporation
 *
 *
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library General Public
 * License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; see the file COPYING.LIB.  If not, write to the
     * Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 *
 */
/**
 * MessageSocketFactory - Builds Sip socket connections
 *
 * @author S.R.Jones
 * @version 1
 *
 */
package org.mitre.jsip;

public class MessageSocketFactory {

    public static MessageSocket getMessageSocket(int type) {

        switch (type) {
            case (MessageSocket.TCP):
                TCPMessageSocket tcpms=new TCPMessageSocket();
                return tcpms;
            case (MessageSocket.UDP):
                UDPMessageSocket udpms=new UDPMessageSocket();
                return udpms;
            case (MessageSocket.MCAST):
                MulticastMessageSocket mcastms=new
                                               MulticastMessageSocket();
                return mcastms;
            default:
                System.out.println(
                    "Unknown socket type. Returning null");
        }
        ;

        return null;
    }
}
