/**
 *
 *
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library General Public
 * License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; see the file COPYING.LIB.  If not, write to the
     * Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 *
 */
/**
 * class UnsupportedMessage
 *
 * This class represents a message of unknown type
 *
 */

package org.mitre.jsip.messages;

import org.mitre.jsip.*;

public class UnsupportedMessage
    extends SipRequestMessage {
    /**
     * Constructor
     */
    public UnsupportedMessage() {
        super();

        meth=Sip.BadMethod;
    }

    protected String startLine() {
        return "";
    }

    protected void validateMessage() throws BadHeaderException {
    }

    public boolean handleNewRequest(SipClient client) {
        client.sendQuickResponse(this, new SipStatus(400));
        return true;
    }

    public void handleCallRequest(SipClient client) {
        client.sendQuickResponse(this, new SipStatus(400));
    }
}
