/**
 * Provide actions that will be repeated at regular intervals. This class
 * assumes that a number of similar actions will need to occur at these
 * intervals, such as a REGISTER message being sent every hour.
 *
 * @author S.R.Jones
 * @version 1
 */
package org.mitre.jsip.util;

import java.util.*;

public class PollAgent
    extends TimerTask {

    // instance variables
    private ArrayList tasks;

    public PollAgent() {
        tasks=new ArrayList();
    }

    public void addTask(PollTask pollTask) {
        if (pollTask==null) {
            return;
        }

        synchronized (this) {
            tasks.add(pollTask);
        }
    }

    public void run() {
        ArrayList list;
        synchronized (this) {
            list= (ArrayList) tasks.clone();
        }

        if ( (list!=null)&& (list.size()>0)) {
            for (int i=0; i<list.size(); i++) {
                PollTask task= (PollTask) list.get(i);
                task.activate();
            }
        }
    }
}
